// Copyright (c) 2016, Herman Bergwerf. All rights reserved.
// Use of this source code is governed by an AGPL-3.0-style license
// that can be found in the LICENSE file.

library molview_dataserver.module.main;

import 'dart:async';

import 'package:omnibus/omnibus.dart';
import 'package:omnibus/patterns.dart';
import 'package:http/http.dart' as http;

import 'package:molview_dataserver/msglib.dart';
import 'package:molview_dataserver/messages_v0.dart' as v0;

part 'state.dart';
part 'storage.dart';
part 'handlers/announce.dart';
part 'handlers/submit_data.dart';
part 'handlers/find_snippets.dart';
part 'handlers/push_active_record.dart';

Future main(Omnibus bus, http.Client httpClient) async {
  // Create one centralized state instance.
  var state = new DataServerState(bus, httpClient);

  // Bind all handlers.
  bus.bind(new v0.AnnounceTableHandler(announceTableHandler, state));
}
