// Copyright (c) 2016, Herman Bergwerf. All rights reserved.
// Use of this source code is governed by an AGPL-3.0-style license
// that can be found in the LICENSE file.

part of molview_dataserver.msglib;

/// Data record
class DataRecord {
  /// Keys by their index in [DataTable.keys]
  final Map<int, dynamic> keys;

  /// Properties by their index in [DataTable.properties]
  final Map<int, dynamic> properties;

  /// Parameters that were used to retrieve this record.
  final Map<String, String> parameters;

  /// Constructor
  DataRecord(this.keys, this.properties, this.parameters);

  /// Construct from PDS.
  factory DataRecord.fromPds(Map<String, dynamic> data) {
    return new DataRecord(
        pdsToIntMap(data['keys']),
        pdsToIntMap(data['properties']),
        data['parameters'] as Map<String, String>);
  }

  /// Convert to PDS.
  Map<String, dynamic> toPds() {
    return {
      'keys': pdsFromMap(keys),
      'properties': pdsFromMap(properties),
      'parameters': pdsFromMap(parameters),
    };
  }
}
