// Copyright (c) 2016, Herman Bergwerf. All rights reserved.
// Use of this source code is governed by an AGPL-3.0-style license
// that can be found in the LICENSE file.

part of molview_dataserver.msglib;

/// Match in a text search
class SearchSuggestion {
  /// Full title of this match.
  final String title;

  /// Entity associated to this match
  final String entity;

  /// Keys linked to this suggestion
  final List<FieldData> keys;

  /// Constructor
  SearchSuggestion(this.title, this.entity, this.keys);

  /// Construct from PDS.
  factory SearchSuggestion.fromPds(Map<String, dynamic> data) {
    return new SearchSuggestion(
        data['title'] as String,
        data['entity'] as String,
        new List<FieldData>.generate(
            data['keys'].length,
            (int i) => new FieldData.fromPds(
                data['keys'][i] as Map<String, dynamic>)));
  }

  /// Convert to PDS.
  Map<String, dynamic> toPds() {
    return {'title': title, 'entity': entity, 'keys': pdsFromList(keys)};
  }
}
